mspe<- function(Observed,Predicted)
{
  
  Obs = Observed[!is.na(Predicted)&!is.na(Observed)]
  Pred = Predicted[!is.na(Predicted)&!is.na(Observed)]
  
  mspe=mean((Obs-Pred)^2, na.rm = TRUE)
  rmspe=sqrt(mspe)
  Prmspe=rmspe/mean(Obs, na.rm = TRUE)
  MSPE<- c(mspe,rmspe,Prmspe)
  names(MSPE)<- c("MSPE", "RMSPE", "RMSPE % of mean")

  
  sp2<- mean((Pred -mean(Pred, na.rm = TRUE))^2, na.rm = TRUE)
  sa2<- mean((Obs-mean(Obs, na.rm = TRUE))^2, na.rm = TRUE)
  r<- (mean((Pred-mean(Pred, na.rm = TRUE))*(Obs-mean(Obs, na.rm = TRUE)))/(sqrt(sp2)*sqrt(sa2)))
  
  ECT<- ((mean(Pred, na.rm = TRUE)-mean(Obs, na.rm = TRUE))^2)/mspe
  ER<- ((sqrt(sp2)-r*sqrt(sa2))^2)/mspe
  ED<- ((1-r^2)*(sa2))/mspe
  Decomp<- c(ECT, ER, ED)
  names(Decomp)<- c("ECT", "ER", "ED")
  
  list(MSPE, Decomp)
  
}
